/*
 * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
 * Copyright (C) 2008 Alp Toker <alp@atoker.com>
 * Copyright (C) 2008 Apple Inc.
 */
#ifndef __GdomXPathResult_H__
#define __GdomXPathResult_H__
#include <webkit/webkitdefines.h>
#include "gdom/GdomDOMObject.h"
#include "gdom/GdomNode.h"
#include "glib-object.h"


G_BEGIN_DECLS

typedef struct _GdomXPathResult GdomXPathResult;
typedef struct _GdomXPathResultClass GdomXPathResultClass;


#define GDOM_TYPE_X_PATH_RESULT            (gdom_x_path_result_get_type())
#define GDOM_X_PATH_RESULT(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_X_PATH_RESULT, GdomXPathResult))
#define GDOM_X_PATH_RESULT_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_X_PATH_RESULT, GdomXPathResult)Class)
#define GDOM_IS_X_PATH_RESULT(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_X_PATH_RESULT))
#define GDOM_IS_X_PATH_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_X_PATH_RESULT))
#define GDOM_X_PATH_RESULT_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_X_PATH_RESULT, GdomXPathResultClass))

typedef struct _GdomXPathResultPrivate GdomXPathResultPrivate;

struct _GdomXPathResult {
    GdomDOMObject parent_instance;
    GdomXPathResultPrivate *priv;
};

struct _GdomXPathResultClass {
    GObjectClass parent_class;
};

WEBKIT_API GType
gdom_x_path_result_get_type (void);

WEBKIT_API GdomNode *
gdom_x_path_result_iterate_next (GdomXPathResult *thiz);

WEBKIT_API GdomNode *
gdom_x_path_result_snapshot_item (GdomXPathResult *thiz, gulong index);

G_END_DECLS

#endif /* __GdomXPathResult_H__ */
